


import numpy as np
import matplotlib.pyplot as plt



'''
Aufgabe 1
'''


' Teilaufgabe a) '


def RGBtoHSV(r, g, b):
    minVal = min(r, g, b)
    maxVal = max(r, g, b)
    
    d = maxVal-minVal
    
    #h berechnen:
    if minVal == maxVal : h = 0
    elif maxVal == r : h = 60*(0+((g-b)/d))
    elif maxVal == g : h = 60*(2+((b-r)/d))
    else : h = 60*(4+((r-g)/d))
    if h < 0 : h = h + 360
    #s berechnen:
    if minVal == maxVal : s = 0
    else : s = d/maxVal
    #v berechnen:
    v = maxVal
    return [h/360.0, s, v]
    


def RGBtoHSVImage(img):
    return np.array([[RGBtoHSV(r, g, b) for r, g, b in row] for row in img])
    
    
    
def aufgabe1a():
    img = plt.imread('nerds.png')
    img2 = RGBtoHSVImage(img)   
    plt.figure(1)
    plt.subplot(221)
    plt.imshow(img)
    plt.subplot(222)
    plt.imshow(img2[:,:,0], cmap=plt.cm.gray)
    plt.subplot(223)
    plt.imshow(img2[:,:,1], cmap=plt.cm.gray)
    plt.subplot(224)
    plt.imshow(img2[:,:,2], cmap=plt.cm.gray)
    plt.show() 
 
 
    
' Teilaufgabe b) '

def whiteBalance(img, rw, gw, bw):
    factorR = 255.0/rw
    factorG = 255.0/gw
    factorB = 255.0/bw
    return np.array([[ [min(1,factorR*r), min(1,factorG*g), min(1,factorB*b)] for r, g, b in row] for row in img])


def aufgabe1b(): # Die Pixel bzw. deren Farbwerte wurden im Folgenden manuell gewaehlt.
    img = plt.imread('white_balance_green-cerfman17.png')
    img2 = whiteBalance(img, 153, 188, 108) 
    img3 = plt.imread('white_balance_red-arturbo.png')
    img4 = whiteBalance(img3, 222, 199, 149)
    img5 = plt.imread('white_balance_red-truester.png')
    img6 = whiteBalance(img5, 230, 197, 104)
    img7 = plt.imread('white-balance-blue-arellis49.png')
    img8 = whiteBalance(img7, 126, 175, 233)
    plt.figure(1)
    plt.subplot(421)
    plt.imshow(img)
    plt.subplot(422)
    plt.imshow(img2)
    plt.subplot(423)
    plt.imshow(img3)
    plt.subplot(424)
    plt.imshow(img4)
    plt.subplot(425)
    plt.imshow(img5)
    plt.subplot(426)
    plt.imshow(img6)
    plt.subplot(427)
    plt.imshow(img7)
    plt.subplot(428)
    plt.imshow(img8)
    plt.show() 



'''
Tests:
'''
    
' Tests ausfuehren (entsprechend ein-/ausklammern): '
if __name__ == '__main__':
    #pass
    aufgabe1a()   
    #aufgabe1b()

